/*
   tp499.c version propia de la funcion signal(), basada en sigaction() para obtener mayor informacion
   acerca de la seal generada. La funcion infosignal() hace lo mismo que signal(), pero provee informacion
   sobre el proceso que  genero la seal.
   
   para compilar:
            gcc -Wall -o tp499 tp499.c 
            
   Guillermo Cherencio
   SO
   UTN FRD
*/
#include <stdio.h>
#include <stdlib.h>
#include	<signal.h>
#include	<unistd.h>
#include <string.h>

typedef void Sigfunc(int);
typedef void Sigfunc2(int,struct siginfo *);
Sigfunc *infosignal(int,Sigfunc2 *);

void sig_usr(int signo,struct siginfo *);
volatile int salir=0;

int main(int argc,char *argv[]) {
   
	if (infosignal(SIGUSR1, sig_usr) == SIG_ERR) fprintf(stderr,"main():imposible capturar SIGUSR1\n");
	if (infosignal(SIGUSR2, sig_usr) == SIG_ERR) fprintf(stderr,"main():imposible capturar SIGUSR2\n");
   pid_t pid = getpid();

	while( !salir ) {
      printf("main(): para probar ejecute: kill -SIGUSR1 %d\n\tpara salir ejecute: kill -SIGUSR2 %d\n",(int) pid,(int) pid);
		pause();
   }
   return 0;
}

// nueva version de signal() basada en sigaction()
Sigfunc *infosignal(int signo,Sigfunc2 *func) {
   struct sigaction act, oact;
   act.sa_handler =  func;
   sigemptyset(&act.sa_mask);
   act.sa_flags = 0;
   if (signo == SIGALRM) {
      #ifdef SA_INTERRUPT
         act.sa_flags |= SA_INTERRUPT | SA_SIGINFO; // sa_siginfo para enviar mayor info al manipulador de la seal
      #endif
   } else {
      #ifdef SA_RESTART
         act.sa_flags |= SA_INTERRUPT | SA_SIGINFO; // sa_siginfo para enviar mayor info al manipulador de la seal
      #endif
   }
   if (sigaction(signo,&act,&oact) < 0)  return SIG_ERR;
   return oact.sa_handler;
}


// funcion para manipulacion de la seal
void sig_usr(int signo,struct siginfo *si)	{	/* signo=nro de seal */
   int p = (int) si->si_pid;
   int u = (int) si->si_uid;
	if (signo == SIGUSR2)  {
      printf("sig_usr():recibi seal SIGUSR2 de proceso %d y usuario %d\n",abs(p),abs(u));
      salir=1;
	} else {
      printf("sig_usr():recibi seal SIGUSR1 de proceso %d y usuario %d\n",abs(p),abs(u));
   }
	return;
}

